/*
	File:		AROSEQ.h

	Contains:	xxx put contents here xxx

	Written by:	xxx put writers here xxx

	Copyright:	 1991 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <2>	 7/15/91	gcc		Changed RegisterTask to Register_Task and LookupTask to Lookup_Task
		 							to match the AROSE convention
		 <1>	 7/15/91	gcc		first checked in

	To Do:
*/

typedef short TAROSEQueue;
typedef TAROSEQueue *TAROSEQueuePtr ;


#define TAROSEQueue_CloseQueue			CloseQueue__11TAROSEQueueFv
#define TAROSEQueue_GetMsg				GetMsg__11TAROSEQueueFv
#define TAROSEQueue_FreeMsg				FreeMsg__11TAROSEQueueFP8mMessage
#define TAROSEQueue_GetCard				GetCard__11TAROSEQueueFv
#define TAROSEQueue_GetETick			GetETick__11TAROSEQueueFv
#define TAROSEQueue_GetICCTID			GetICCTID__11TAROSEQueueFv
#define TAROSEQueue_GetNameTID			GetNameTID__11TAROSEQueueFv
#define TAROSEQueue_GetTickPS			GetTickPS__11TAROSEQueueFv
#define TAROSEQueue_GetTID				GetTID__11TAROSEQueueFv
#define TAROSEQueue_IsLocal				IsLocal__11TAROSEQueueFPc
#define TAROSEQueue_KillReceive			KillReceive__11TAROSEQueueFv
#define TAROSEQueue_LockRealArea		LockRealArea__11TAROSEQueueFPvUlP12addressareasT2
#define TAROSEQueue_Lookup_Task			Lookup_Task__11TAROSEQueueFPcT1lPUs
#define TAROSEQueue_NetCopy				NetCopy__11TAROSEQueueFlPvT1T2Ul
#define TAROSEQueue_OpenQueue			OpenQueue__11TAROSEQueueFPFv_v
#define TAROSEQueue_Receive				Receive__11TAROSEQueueFUllUsT2PFP8mMessage_v
#define TAROSEQueue_Register_Task		Register_Task__11TAROSEQueueFPcT1s
#define TAROSEQueue_Send				Send__11TAROSEQueueFP8mMessage
#define TAROSEQueue_SwapTID				SwapTID__11TAROSEQueueFP8mMessage
#define TAROSEQueue_UnLockRealArea		UnLockRealArea__11TAROSEQueueFPvUl
#define TAROSEQueue_FreeMem				AROSEFreeMem__11TAROSEQueueFPc
#define TAROSEQueue_GetMem				AROSEGetMem__11TAROSEQueueFl
#define TAROSEQueue_GetTraceTID			GetTraceTID__11TAROSEQueueFv
#define TAROSEQueue_CountFreeMsgs		CountFreeMsgs__11TAROSEQueueFv

void 			TAROSEQueue_CloseQueue(TAROSEQueuePtr);
void			TAROSEQueue_FreeMsg(TAROSEQueuePtr,mMessage *msgPtr);
char			TAROSEQueue_GetCard(TAROSEQueuePtr);
unsigned long	TAROSEQueue_GetETick(TAROSEQueuePtr);
tid_type		TAROSEQueue_GetICCTID(TAROSEQueuePtr);
mMessage*		TAROSEQueue_GetMsg(TAROSEQueuePtr);
tid_type		TAROSEQueue_GetNameTID(TAROSEQueuePtr);
unsigned short	TAROSEQueue_GetTickPS(TAROSEQueuePtr);
tid_type		TAROSEQueue_GetTID(TAROSEQueuePtr);
short			TAROSEQueue_IsLocal(TAROSEQueuePtr,char *address);
void			TAROSEQueue_KillReceive(TAROSEQueuePtr);
short			TAROSEQueue_LockRealArea(TAROSEQueuePtr,void *virtualAddr, unsigned long length,
						struct addressareas buffer[], unsigned long count);
tid_type		TAROSEQueue_Lookup_Task(TAROSEQueuePtr,char *object, char *type, tid_type nm_TID,
									unsigned short *index);
short			TAROSEQueue_NetCopy(TAROSEQueuePtr,tid_type srcTID, void *srcAddress,
							tid_type dstTID, void *dstAddress,
									unsigned long byteCount);
tid_type		TAROSEQueue_OpenQueue(TAROSEQueuePtr,void (*UserProcedure)(void));
mMessage*		TAROSEQueue_Receive(TAROSEQueuePtr,unsigned long mID, tid_type mFrom,
								unsigned short mCode, long timeOut,
								void (*CompletionRoutine)(mMessage *));
char			TAROSEQueue_Register_Task(TAROSEQueuePtr,char object[], char type[], short local_only);
void			TAROSEQueue_Send(TAROSEQueuePtr,mMessage *msgPtr);
void			TAROSEQueue_SwapTID(TAROSEQueuePtr,mMessage *msgPtr);
void			TAROSEQueue_UnLockRealArea(TAROSEQueuePtr,void *virtualAddr, unsigned long length);
char			*TAROSEQueue_GetMem(TAROSEQueuePtr, long theSize);
void			TAROSEQueue_FreeMem(TAROSEQueuePtr, char * thePtr);
tid_type		TAROSEQueue_GetTraceTID(TAROSEQueuePtr);
long			TAROSEQueue_CountFreeMsgs(TAROSEQueuePtr);