/*
	File:		AROSEQueue.h

	Contains:	xxx put contents here xxx

	Written by:	xxx put writers here xxx

	Copyright:	 1991 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <4>	 7/17/91	gcc		Change order to match AROSEQueueGlue.a
		 <2>	 7/15/91	gcc		Change GetMyQueueId to return void
		 <1>	 7/15/91	gcc		first checked in

	To Do:
*/

#ifndef __AROSEQUEUE__
#define __AROSEQUEUE__

#ifndef	__TYPES__
#include <Types.h>
#endif

#ifndef	__RESOURCES__
#include <Resources.h>
#endif

#ifndef __MEMORY__
#include <Memory.h>
#endif

#ifndef	_os_defined_
#include "os.h"
#endif

pascal void GetMyQueueId() = {0x206e, 0x0008};

class TAROSEQueue;
typedef TAROSEQueue *TAROSEQueuePtr;

class TAROSEQueue : public SingleObject {
	public:
						TAROSEQueue();		/* constuctor */
						~TAROSEQueue();		/* destructor */
		void			CloseQueue(void);
		void			FreeMsg(mMessage *msgPtr);
		char			GetCard(void);
		unsigned long	GetETick(void);
		tid_type		GetICCTID(void);
		mMessage*		GetMsg(void);
		tid_type		GetNameTID(void);
		unsigned short	GetTickPS(void);
		tid_type		GetTID(void);
		short			IsLocal(char *address);
		void			KillReceive(void);
		short			LockRealArea(void *virtualAddr, unsigned long length,
								struct addressareas buffer[], unsigned long count);
		tid_type		Lookup_Task(char *object, char *type, tid_type nm_TID,
											unsigned short *index);
		short			NetCopy(tid_type srcTID, void *srcAddress,
									tid_type dstTID, void *dstAddress,
											unsigned long byteCount);
		tid_type		OpenQueue(void (*UserProcedure)(void));
		mMessage*		Receive(unsigned long mID, tid_type mFrom,
										unsigned short mCode, long timeOut,
										void (*CompletionRoutine)(mMessage *));
		char			Register_Task(char object[], char type[], short local_only);
		void			Send(mMessage *msgPtr);
		void			SwapTID(mMessage *msgPtr);
		void			UnlockRealArea(void *virtualAddr, unsigned long length);
		void			TraceReg(void);
		tid_type		GetTraceTID(void);
		void			PushAIPC();
		char			*AROSEGetMem(long);
		void			AROSEFreeMem(char *);
		long			CountFreeMsgs();
		
	private:
		short			fQueueId;
};

// additional AROSE typedefs
typedef	AROSEmessage*					AROSEMessagePtr;
typedef tid_type						AROSETaskId;


const kLocallyVisible = 1;
const kNonBlocking = -1;


#endif
