/****************************************************************************************/
/*																						*/
/*						name_tester - A/ROSE Prep name test task.						*/
/*																						*/
/*																						*/
/*					Richard W. Mincher.						05/01/87.					*/
/*					Philip Rakity							08/20/87					*/
/*																						*/
/*				Copyright  1987-88, Apple Computer, Inc.  All rights reserved.			*/
/*																						*/
/****************************************************************************************/

#include "os.h"
#include "arose.h"
#include "managers.h"
#include <stdio.h>


pascal	void	illegal ()
		extern	0x4afc;

static	char	tester_name [] = "tester program";
static	short	test_number;
static	message	*msgptr;
static	message	*p;

#define TRUE	1
#define	FALSE	0
main ()
{
	short						i;
	tid_type					name_server_tid;
	tid_type					my_tid;
	struct	pb_lookup_name		*lnam_ptr;
	struct	pb_unregister_name	*lunr_ptr, punr_buffer;
	struct ra_GetCards			get_cards;
	tid_type					tid;
	unsigned short				index;
	void						unregister ();
	struct lname_pb
	{	
		char	x[513];
	} buffer;

	atexit (unregister);
	
	OpenQueue (0);	
	
	test_number = 0;
	name_server_tid = GetNameTID ();
	my_tid = GetTID ();

	printf("tester task starting.tid = %x - ICC TID = %x\n", GetTID (), GetICCTID ());

	
	/* register task test						*/
	
	if (!Register_Task ("tester", "pmr", Locally_Visible))	
		illegal ();
	
	if (Register_Task ("tester", "pmr", Locally_Visible))	
		illegal ();									/* Insure we fail to register 2nd time */
	
	if (!Register_Task ("testerMachine_Visible", "pmr", Machine_Visible))	
		illegal ();
	
	if (Register_Task ("testerMachine_Visible", "pmr", Machine_Visible))	
		illegal ();									/* Insure we fail to register 2nd time */

	/* lookup process id test					*/
	
	test_number++;

	index = 0;
	tid = Lookup_Task ("tester", "pmr", name_server_tid, &index);
	
	printf ("Task tester - tid = %x\n", tid);
	fflush (stdout);
	/* lookup name test							*/
	
	test_number++;

	if ((msgptr = GetMsg ()) == NULL)
		illegal ();

	msgptr -> mCode = NM_LOOKUP_NAME;

	lnam_ptr = (struct pb_lookup_name *) &buffer;
		
	msgptr -> mDataPtr = (char *) lnam_ptr;
	msgptr -> mDataSize = sizeof (struct lname_pb);
	msgptr -> mTo = name_server_tid;
	
	lnam_ptr -> lnm_index = 0;
	lnam_ptr -> lnm_tid = my_tid;
	lnam_ptr -> lnm_RAsize = sizeof (struct lname_pb) - (sizeof (struct pb_lookup_name)
											- sizeof (struct ra_lnm));
											
	Send (msgptr);

	msgptr = Receive (OS_MATCH_ALL, OS_MATCH_ALL, NM_LOOKUP_NAME+1, OS_NO_TIMEOUT, 0);
	
	if((long) msgptr <= 0)
		illegal ();
		
	printf ("object name = \"%s\", type name = \"%s\"\n",
			((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [0].ra_on.o_name,
			((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [0].ra_tn.t_name);
		
	fflush (stdout);
	FreeMsg (msgptr);

	/* unregister name test							*/
	
	test_number++;
	
	/* Register two other names to have things to more things to unregister */
	
	if (!Register_Task ("Name1", "pmr", Locally_Visible))	
		illegal ();
	
	if (!Register_Task ("Name2", "pmr", Locally_Visible))	
		illegal ();
	
	if ((msgptr = GetMsg ()) == NULL)
		illegal ();

	msgptr -> mCode = NM_LOOKUP_NAME;	

	lnam_ptr = (struct pb_lookup_name *) &buffer;
				
	msgptr -> mDataPtr = (char *) lnam_ptr;
	msgptr -> mDataSize = sizeof (struct lname_pb);
	msgptr -> mTo = name_server_tid;
	
	lnam_ptr -> lnm_index = 0;
	lnam_ptr -> lnm_tid = my_tid;
	lnam_ptr -> lnm_RAsize = sizeof (struct lname_pb) - (sizeof (struct pb_lookup_name)
											- sizeof (struct ra_lnm));
											
	Send (msgptr);

	msgptr = Receive (OS_MATCH_ALL, OS_MATCH_ALL, NM_LOOKUP_NAME+1, OS_NO_TIMEOUT, 0);
	
	printf ("TID = %x - object name = \"%s\", type name = \"%s\"\n", GetTID (),
			((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [0].ra_on.o_name,
			((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [0].ra_tn.t_name);
	printf ("TID = %x - object name = \"%s\", type name = \"%s\"\n", GetTID (),
			((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [1].ra_on.o_name,
			((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [1].ra_tn.t_name);
	printf ("TID = %x - object name = \"%s\", type name = \"%s\"\n", GetTID (),
			((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [2].ra_on.o_name,
			((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [2].ra_tn.t_name);

	lunr_ptr = &punr_buffer;
	
	if ((p = GetMsg ()) == NULL)
		illegal ();
	
	p -> mCode = NM_UNREG_NAME;
	p -> mDataPtr = (char *)  lunr_ptr;
	p -> mDataSize = sizeof (struct pb_unregister_name);
	p -> mTo = name_server_tid;
	strcpy(lunr_ptr -> ut_on.o_name, "Name1");

	lunr_ptr -> ut_on.o_len = sizeof ("Name1") - 1;	/* Do not include zero byte in length! */
	
	strcpy(lunr_ptr -> ut_tn.t_name, "pmr");
	lunr_ptr -> ut_tn.t_len = sizeof ("pmr") - 1;	/* Do not include zero byte in length! */
	
	Send(p);
	
	p = Receive (OS_MATCH_ALL, OS_MATCH_ALL, NM_UNREG_NAME+1, OS_NO_TIMEOUT, 0);
	
	printf ("TID = %x - object name = \"%s\", type name = \"%s\", status = %x\n", GetTID (),
			((struct pb_unregister_name *) (p -> mDataPtr)) -> ut_on.o_name,
			((struct pb_unregister_name *) (p -> mDataPtr)) -> ut_tn.t_name,
			p -> mStatus);
	
	msgptr -> mTo = name_server_tid;
	msgptr -> mFrom = my_tid;
	msgptr -> mCode = NM_LOOKUP_NAME;	
	lnam_ptr -> lnm_index = 0;
	lnam_ptr -> lnm_tid = my_tid;
	lnam_ptr -> lnm_RAsize = sizeof (struct lname_pb) - (sizeof (struct pb_lookup_name)
											- sizeof (struct ra_lnm));
											
	Send (msgptr);
	msgptr = Receive (OS_MATCH_ALL, OS_MATCH_ALL, NM_LOOKUP_NAME+1, OS_NO_TIMEOUT, 0);
	
	printf ("TID = %x - object name = \"%s\", type name = \"%s\"\n", GetTID (),
			((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [0].ra_on.o_name,
			((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [0].ra_tn.t_name);
	printf ("TID = %x - object name = \"%s\", type name = \"%s\"\n", GetTID (),
			((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [1].ra_on.o_name,
			((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [1].ra_tn.t_name);

	FreeMsg (msgptr);
	FreeMsg (p);
	
	/* unregister task  test								*/

	test_number++;
	
	if ((msgptr = GetMsg ()) == NULL)
		illegal ();

	msgptr -> mCode = NM_UNREG_TASK;
	msgptr -> mTo = name_server_tid;
	
	Send (msgptr);

	msgptr = Receive (OS_MATCH_ALL, OS_MATCH_ALL, NM_UNREG_TASK+1, OS_NO_TIMEOUT, 0);

	if((long) msgptr <= 0)
		illegal ();

	FreeMsg (msgptr);
	
	/* lookup name test								*/
	
	test_number++;

	if ((msgptr = GetMsg ()) == NULL)
		illegal ();

	msgptr -> mCode = NM_LOOKUP_NAME;

	lnam_ptr = (struct pb_lookup_name *) &buffer;
		
	msgptr -> mDataPtr = (char *) lnam_ptr;
	msgptr -> mDataSize = sizeof (struct lname_pb);
	msgptr -> mTo = name_server_tid;
	
	lnam_ptr -> lnm_index = 0;
	lnam_ptr -> lnm_tid = my_tid;
	lnam_ptr -> lnm_RAsize = sizeof (struct lname_pb) - (sizeof (struct pb_lookup_name)
											- sizeof (struct ra_lnm));
	((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [0].ra_on.o_name [0] = 0;
	((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [0].ra_tn.t_name [0] = 0;
											
	Send (msgptr);

	msgptr = Receive (OS_MATCH_ALL, OS_MATCH_ALL, NM_LOOKUP_NAME+1, OS_NO_TIMEOUT, 0);

	if((long) msgptr <= 0)
		illegal ();

	printf ("object name = \"%s\", type name = \"%s\"\n",
			((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [0].ra_on.o_name,
			((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [0].ra_tn.t_name);
		
	FreeMsg (msgptr);
	printf ("starting timer delay test\n");
	fflush (stdout);
	test_number++;
	msgptr = Receive( 0x100, 0x101, 0x102, GetTickPS () * 6,0 );
	if ((long) msgptr > 0)
		illegal ();
		

	if (GetICCTID () != 0)
	{
		if ((msgptr = GetMsg ()) == NULL)
			illegal ();
	
		msgptr -> mCode = ICC_GETCARDS;
		msgptr -> mDataPtr = (char *) &get_cards;
		msgptr -> mDataSize = sizeof (struct ra_GetCards);
		msgptr -> mTo = GetICCTID ();
		Send (msgptr);
		
		msgptr = Receive (OS_MATCH_ALL, OS_MATCH_ALL, ICC_GETCARDS+1,  OS_NO_TIMEOUT,0);
				
		if((long) msgptr <= 0)
			illegal ();

		if (msgptr -> mStatus == 0)
		{
			for (i = 0; i < 16; i++)
			{
				if (get_cards.tid [i] > 0)
				{
					printf("Tester Task %x - Entry %x - TID Found %x\n",
									my_tid, i, get_cards.tid [i]);
					index = 0;
					while ((tid = Lookup_Task ("=", "=", get_cards.tid [i], &index)))
						printf ("%x TID FOUND, tid = %x\n", my_tid, tid);
					fflush (stdout);
				}
			}
		}
		else
			printf ("Tester Task %x - ICCM message bad status %x \n", 
										my_tid, msgptr -> mStatus);
		FreeMsg (msgptr);
		fflush (stdout);
	}
	else
	{
		printf ("GetICCTID Failed\n");
		illegal ();
	}

	
	printf ("Tester task = TicksPerSec = %d\n", GetTickPS());
	printf("Tester task going away.\n");
	fflush (stdout);
	CloseQueue ();
	exit(0);
}

void unregister ()
{
			
	CloseQueue ();
	printf ("CloseQueue Called\n");
	fflush (stdout);
}


